diff -urNEBb gcc-2.95.3-orig/configure.in gcc-2.95.3/configure.in
--- gcc-2.95.3-orig/configure.in	1999-06-23 00:44:40.000000000 +0200
+++ gcc-2.95.3/configure.in	2003-12-02 17:50:54.000000000 +0100
@@ -439,7 +439,7 @@
   *) x=${exec_prefix} ;;
   esac
   for l in ${with_libs}; do
-    copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
+    echo Skipping lib copy
   done
 fi
 
diff -urNEBb gcc-2.95.3-orig/gcc/c-typeck.c gcc-2.95.3/gcc/c-typeck.c
--- gcc-2.95.3-orig/gcc/c-typeck.c	2001-01-25 15:03:00.000000000 +0100
+++ gcc-2.95.3/gcc/c-typeck.c	2003-12-02 17:50:55.000000000 +0100
@@ -1569,6 +1569,14 @@
   /* fntype now gets the type of function pointed to.  */
   fntype = TREE_TYPE (fntype);
 
+  if (lookup_attribute("libcall", TYPE_ATTRIBUTES(fntype))) 
+   if (TREE_CODE(function)==COMPONENT_REF)
+    params = chainon (build_tree_list(NULL_TREE, 
+                                      build1(ADDR_EXPR,build_pointer_type(TREE_TYPE(TREE_OPERAND(function,0))),
+				             TREE_OPERAND(function,0))
+				      )
+		      , params);
+
   /* Convert the parameters to the types declared in the
      function prototype, or apply default promotions.  */
 
diff -urNEBb gcc-2.95.3-orig/gcc/cccp.c gcc-2.95.3/gcc/cccp.c
--- gcc-2.95.3-orig/gcc/cccp.c	2001-01-25 15:03:00.000000000 +0100
+++ gcc-2.95.3/gcc/cccp.c	2003-12-02 17:50:55.000000000 +0100
@@ -85,7 +85,7 @@
 
 /* Windows does not natively support inodes, and neither does MSDOS.  */
 #if (defined (_WIN32) && ! defined (__CYGWIN__) && ! defined (_UWIN)) \
-  || defined (__MSDOS__)
+  || defined (__MSDOS__) || defined (__amigaos__)
 #define INO_T_EQ(a, b) 0
 #endif
 
@@ -101,8 +101,15 @@
 #define INCLUDE_LEN_FUDGE 0
 #endif
 
+#undef OPEN_CASE_SENSITIVE
+
 /* External declarations.  */
 
+#ifndef OPEN_CASE_SENSITIVE
+/* Default is standard open() */
+#define OPEN_CASE_SENSITIVE open
+#endif
+
 extern char *version_string;
 HOST_WIDEST_INT parse_escape PROTO((char **, HOST_WIDEST_INT));
 HOST_WIDEST_INT parse_c_expression PROTO((char *, int));
@@ -1918,7 +1925,12 @@
 	notice ("#include <...> search starts here:\n");
       if (!p->fname[0])
 	fprintf (stderr, " .\n");
-      else if (!strcmp (p->fname, "/") || !strcmp (p->fname, "//"))
+      else if (!strcmp (p->fname, "/") || !strcmp (p->fname, "//")
+#ifdef VOL_SEPARATOR
+	/* Don't omit the last character if it's not a '/'.  */
+	       || p->fname[strlen (p->fname) - 1] != '/'
+#endif
+	       )
 	fprintf (stderr, " %s\n", p->fname);
       else
 	/* Omit trailing '/'.  */
@@ -4785,6 +4797,9 @@
 #ifdef DIR_SEPARATOR
   if ((p = rindex (s, DIR_SEPARATOR))) s = p + 1;
 #endif
+#ifdef VOL_SEPARATOR
+  if ((p = rindex (s, VOL_SEPARATOR))) s = p + 1;
+#endif
   return s;
 }
 
@@ -4794,6 +4809,7 @@
 absolute_filename (filename)
      char *filename;
 {
+#ifndef FILE_NAME_ABSOLUTE_P
 #if defined (__MSDOS__) \
   || (defined (_WIN32) && !defined (__CYGWIN__) && !defined (_UWIN))
   if (ISALPHA (filename[0]) && filename[1] == ':') filename += 2;
@@ -4810,6 +4826,9 @@
   if (filename[0] == DIR_SEPARATOR) return 1;
 #endif
   return 0;
+#else /* FILE_NAME_ABSOLUTE_P */
+  return FILE_NAME_ABSOLUTE_P (filename);
+#endif /* FILE_NAME_ABSOLUTE_P */
 }
 
 /* Returns whether or not a given character is a directory separator.
@@ -5072,7 +5091,7 @@
       || ! inc->control_macro
       || (inc->control_macro[0] && ! lookup (inc->control_macro, -1, -1))) {
 
-    fd = open (fname, O_RDONLY, 0);
+    fd = OPEN_CASE_SENSITIVE (fname, O_RDONLY, 0);
 
     if (fd < 0)
       {
@@ -10406,7 +10425,12 @@
     len = simplify_filename (dir->fname);
 
     /* Convert directory name to a prefix.  */
-    if (len && dir->fname[len - 1] != DIR_SEPARATOR) {
+    if (len && dir->fname[len - 1] != DIR_SEPARATOR
+#ifdef VOL_SEPARATOR
+	&& dir->fname[len - 1] != VOL_SEPARATOR
+#endif
+	)
+    {
       if (len == 1 && dir->fname[len - 1] == '.')
 	len = 0;
       else
diff -urNEBb gcc-2.95.3-orig/gcc/collect2.c gcc-2.95.3/gcc/collect2.c
--- gcc-2.95.3-orig/gcc/collect2.c	2001-01-25 15:03:01.000000000 +0100
+++ gcc-2.95.3/gcc/collect2.c	2003-12-06 19:26:25.000000000 +0100
@@ -30,6 +30,11 @@
 #include "system.h"
 #include <signal.h>
 
+#ifdef __amigaos4__
+#define NSIG 6
+#define NO_SYS_SIGLIST
+#endif
+
 #ifdef vfork /* Autoconf may define this to fork for us. */
 # define VFORK_STRING "fork"
 #else
@@ -1094,6 +1099,9 @@
 #endif
 
   /* Extract COMPILER_PATH and PATH into our prefix list.  */
+#ifdef __amigaos4__
+  prefix_from_string ("/gcc/bin", &cpath);
+#endif    
   prefix_from_env ("COMPILER_PATH", &cpath);
   prefix_from_env ("PATH", &path);
 
@@ -2238,6 +2246,8 @@
    constructor functions, terminated with a null pointer.  The
    destructor table has the same format, and begins at __DTOR_LIST__.  */
 
+#ifndef __amigaos4__
+
 static void
 scan_prog_file (prog_name, which_pass)
      char *prog_name;
@@ -2400,7 +2410,199 @@
   signal (SIGQUIT, quit_handler);
 #endif
 }
+#else
+
+
+static void
+scan_prog_file (prog_name, which_pass)
+     char *prog_name;
+     enum pass which_pass;
+{
+  void (*int_handler) ();
+  void (*quit_handler) ();
+  char *nm_argv[4];
+  int pid;
+  int argc = 0;
+  int pipe_fd[2];
+  char *p, buf[1024];
+  FILE *inf;
+  char *scmd,*s;
+  int i, j,len,arglen,c,need_quote;
+
+  if (which_pass == PASS_SECOND)
+    return;
+
+  /* If we do not have an `nm', complain.  */
+  if (nm_file_name == 0)
+    fatal ("cannot find `nm'");
+
+  nm_argv[argc++] = nm_file_name;
+  if (NM_FLAGS[0] != '\0')
+    nm_argv[argc++] = NM_FLAGS;
+
+  nm_argv[argc++] = prog_name;
+  nm_argv[argc++] = (char *) 0;
+
+
+  len = 0;
+
+  for(i = 0 ; nm_argv[i] != NULL ; i++)
+  {
+    arglen = strlen(nm_argv[i]);
+
+    len += 1 + arglen;
+
+    for(j = 0, need_quote = 0 ; j < arglen ; j++)
+    {
+      c = nm_argv[i][j];
+
+      if(c == ' ')
+        need_quote = 1;
+      else if (c == '\"')
+        len++;
+    }
+
+    if(need_quote)
+      len += 2;
+  }
+
+  s = scmd = (char *) xmalloc (len+1);
+
+  for(i = 0 ; nm_argv[i] != NULL ; i++)
+  {
+    arglen = strlen(nm_argv[i]);
+
+    for(j = 0, need_quote = 0 ; j < arglen ; j++)
+    {
+      if(nm_argv[i][j] == ' ')
+        need_quote = 1;
+    }
+
+    if(s != scmd)
+      (*s++) = ' ';
+
+    if(need_quote)
+      (*s++) = '\"';
+
+    for(j = 0 ; j < arglen ; j++)
+    {
+      c = nm_argv[i][j];
+      if(c == '\"')
+        (*s++) = '*';
+
+      (*s++) = c;
+    }
+
+    if(need_quote)
+      (*s++) = '\"';
+  }
+
+  (*s) = '\0';
+
+  /* Trace if needed.  */
+  if (vflag)
+    {
+      char **p_argv;
+      char *str;
+
+      for (p_argv = &nm_argv[0]; (str = *p_argv) != (char *) 0; p_argv++)
+	fprintf (stderr, " %s", str);
+
+      fprintf (stderr, "\n");
+    }
+
+  fflush (stdout);
+  fflush (stderr);
+
+  inf = popen(scmd,"r");
+  if (inf == (FILE *) NULL)
+    fatal_perror ("popen");
+
+  free(scmd);
+
+  if (debug)
+    fprintf (stderr, "\nnm output with constructors/destructors.\n");
+
+  /* Read each line of nm output.  */
+  while (fgets (buf, sizeof buf, inf) != (char *) 0)
+    {
+      int ch, ch2;
+      char *name, *end;
+	  
+      /* If it contains a constructor or destructor name, add the name
+	 to the appropriate list.  */
+
+      for (p = buf; (ch = *p) != '\0' && ch != '\n' && ch != '_'; p++)
+	if (ch == ' ' && p[1] == 'U' && p[2] == ' ')
+	  break;
+
+      if (ch != '_')
+	continue;
+  
+      name = p;
+      /* Find the end of the symbol name.
+	 Do not include `|', because Encore nm can tack that on the end.  */
+      for (end = p; (ch2 = *end) != '\0' && !ISSPACE (ch2) && ch2 != '|';
+	   end++)
+	continue;
+
+
+      *end = '\0';
+
+      switch (is_ctor_dtor (name))
+	{
+	case 1:
+	  if (which_pass != PASS_LIB)
+	    add_to_list (&constructors, name);
+	  break;
+
+	case 2:
+	  if (which_pass != PASS_LIB)
+	    add_to_list (&destructors, name);
+	  break;
+
+	case 3:
+	  if (which_pass != PASS_LIB)
+	    fatal ("init function found in object %s", prog_name);
+#ifndef LD_INIT_SWITCH
+	  add_to_list (&constructors, name);
+#endif
+	  break;
+
+	case 4:
+	  if (which_pass != PASS_LIB)
+	    fatal ("fini function found in object %s", prog_name);
+#ifndef LD_FINI_SWITCH
+	  add_to_list (&destructors, name);
+#endif
+	  break;
+
+	case 5:
+	  if (which_pass != PASS_LIB)
+	    add_to_list (&frame_tables, name);
+	  break;
+
+	default:		/* not a constructor or destructor */
+	  continue;
+	}
+
+      if (debug)
+	fprintf (stderr, "\t%s\n", buf);
+    }
+
+  if (debug)
+    fprintf (stderr, "\n");
+
+  if (fclose (inf) != 0)
+    fatal_perror ("fclose");
+
+  signal (SIGINT,  int_handler);
+#ifdef SIGQUIT
+  signal (SIGQUIT, quit_handler);
+#endif
+}
 
+#endif
 #if SUNOS4_SHARED_LIBRARIES
 
 /* Routines to scan the SunOS 4 _DYNAMIC structure to find shared libraries
@@ -2571,9 +2773,14 @@
 	      }
 	}
       /* built in directories are /lib, /usr/lib, and /usr/local/lib */
+#ifdef __amigaos4__
+      *pp++ = "/gcc/lib";
+      *pp++ = "/gcc/local/lib";
+#else
       *pp++ = "/lib";
       *pp++ = "/usr/lib";
       *pp++ = "/usr/local/lib";
+#endif      
       *pp = 0;
     }
   libname = name;
diff -urNEBb gcc-2.95.3-orig/gcc/config/arm/coff.h gcc-2.95.3/gcc/config/arm/coff.h
--- gcc-2.95.3-orig/gcc/config/arm/coff.h	1999-03-22 17:32:25.000000000 +0100
+++ gcc-2.95.3/gcc/config/arm/coff.h	2003-12-02 17:50:55.000000000 +0100
@@ -41,9 +41,10 @@
    command line option -mstructure_size_boundary=<n> can be used to change this
    value.  */
 #undef  STRUCTURE_SIZE_BOUNDARY
-#define STRUCTURE_SIZE_BOUNDARY arm_structure_size_boundary
+/*#define STRUCTURE_SIZE_BOUNDARY arm_structure_size_boundary*/
+#define STRUCTURE_SIZE_BOUNDARY 32
 
-extern int arm_structure_size_boundary;
+/*extern int arm_structure_size_boundary;*/
 
 /* A C expression whose value is nonzero if IDENTIFIER with arguments ARGS
    is a valid machine specific attribute for DECL.
diff -urNEBb gcc-2.95.3-orig/gcc/config/arm/elf.h gcc-2.95.3/gcc/config/arm/elf.h
--- gcc-2.95.3-orig/gcc/config/arm/elf.h	1999-05-31 10:21:53.000000000 +0200
+++ gcc-2.95.3/gcc/config/arm/elf.h	2003-12-02 17:50:55.000000000 +0100
@@ -172,9 +172,10 @@
    command line option -mstructure_size_boundary=<n> can be used to change this
    value.  */
 #undef  STRUCTURE_SIZE_BOUNDARY
-#define STRUCTURE_SIZE_BOUNDARY arm_structure_size_boundary
+/*#define STRUCTURE_SIZE_BOUNDARY arm_structure_size_boundary*/
+#define STRUCTURE_SIZE_BOUNDARY 32
 
-extern int arm_structure_size_boundary;
+/*extern int arm_structure_size_boundary;*/
 
 /* A C expression whose value is nonzero if IDENTIFIER with arguments ARGS
    is a valid machine specific attribute for DECL.
diff -urNEBb gcc-2.95.3-orig/gcc/config/arm/tcoff.h gcc-2.95.3/gcc/config/arm/tcoff.h
--- gcc-2.95.3-orig/gcc/config/arm/tcoff.h	1998-12-16 22:01:58.000000000 +0100
+++ gcc-2.95.3/gcc/config/arm/tcoff.h	2003-12-02 17:50:55.000000000 +0100
@@ -33,9 +33,10 @@
    command line option -mstructure_size_boundary=<n> can be used to change this
    value.  */
 #undef STRUCTURE_SIZE_BOUNDARY
-#define STRUCTURE_SIZE_BOUNDARY arm_structure_size_boundary
+/*#define STRUCTURE_SIZE_BOUNDARY arm_structure_size_boundary*/
+#define STRUCTURE_SIZE_BOUNDARY 32
 
-extern int arm_structure_size_boundary;
+/*extern int arm_structure_size_boundary;*/
 
 /* This is COFF, but prefer stabs.  */
 #define SDB_DEBUGGING_INFO
diff -urNEBb gcc-2.95.3-orig/gcc/config/m68k/amigaos.c gcc-2.95.3/gcc/config/m68k/amigaos.c
--- gcc-2.95.3-orig/gcc/config/m68k/amigaos.c	1970-01-01 01:00:00.000000000 +0100
+++ gcc-2.95.3/gcc/config/m68k/amigaos.c	2003-12-02 17:50:55.000000000 +0100
@@ -0,0 +1,419 @@
+/* Configuration for GNU C-compiler for m68k Amiga, running AmigaOS.
+   Copyright (C) 1992, 93-96, 1997 Free Software Foundation, Inc.
+   Contributed by Markus M. Wild (wild@amiga.physik.unizh.ch).
+   Heavily modified by Kamil Iskra (iskra@student.uci.agh.edu.pl).
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU CC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU CC; see the file COPYING.  If not, write to
+the Free Software Foundation, 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#include "config.h"
+#include "system.h"
+#include "rtl.h"
+#include "output.h"
+#include "tree.h"
+#include "flags.h"
+#include "expr.h"
+
+/* Baserel support.  */
+
+/* Does operand (which is a symbolic_operand) live in text space? If
+   so SYMBOL_REF_FLAG, which is set by ENCODE_SECTION_INFO, will be true.
+
+   This function is used in base relative code generation. */
+
+int
+read_only_operand (operand)
+     rtx operand;
+{
+  if (GET_CODE (operand) == CONST)
+    operand = XEXP (XEXP (operand, 0), 0);
+  if (GET_CODE (operand) == SYMBOL_REF)
+    return SYMBOL_REF_FLAG (operand) || CONSTANT_POOL_ADDRESS_P (operand);
+  return 1;
+}
+
+/* This function is used while generating a base relative code.
+   It returns 1 if a decl is not relocatable, i. e., if it can be put
+   in the text section.
+   Currently, it's very primitive: it just checks if the object size
+   is less than 4 bytes (i. e., if it can hold a pointer).  It also
+   supports arrays and floating point types.  */
+
+int
+amigaos_put_in_text (decl)
+     tree decl;
+{
+  tree type = TREE_TYPE (decl);
+  if (TREE_CODE (type) == ARRAY_TYPE)
+    type = TREE_TYPE (type);
+  return (TREE_INT_CST_HIGH (TYPE_SIZE (type)) == 0
+	  && TREE_INT_CST_LOW (TYPE_SIZE (type)) < 32)
+	 || FLOAT_TYPE_P (type);
+}
+
+/* Common routine used to check if a4 should be preserved/restored.  */
+
+int
+amigaos_restore_a4 ()
+{
+  return (flag_pic >= 3 &&
+	  (TARGET_RESTORE_A4 || TARGET_ALWAYS_RESTORE_A4
+	   || lookup_attribute ("saveds",
+				TYPE_ATTRIBUTES (TREE_TYPE (current_function_decl)))));
+}
+
+void
+amigaos_alternate_pic_setup (stream)
+     FILE *stream;
+{
+  if (TARGET_RESTORE_A4 || TARGET_ALWAYS_RESTORE_A4)
+    asm_fprintf (stream, "\tjbsr %U__restore_a4\n");
+  else if (lookup_attribute ("saveds",
+			     TYPE_ATTRIBUTES (TREE_TYPE (current_function_decl))))
+    asm_fprintf (stream, "\tlea %U__a4_init,%Ra4\n");
+}
+
+/* Attributes support.  */
+
+#define AMIGA_CHIP_SECTION_NAME ".datachip"
+
+/* Return nonzero if IDENTIFIER with arguments ARGS is a valid machine
+   specific attribute for DECL.  The attributes in ATTRIBUTES have previously
+   been assigned to DECL. */
+
+int
+valid_amigaos_decl_attribute (decl, identifier)
+     tree decl, identifier;
+{
+  if (TREE_CODE (decl) == VAR_DECL)
+    if (is_attribute_p ("chip", identifier))
+#ifdef ASM_OUTPUT_SECTION_NAME
+      {
+	if (! TREE_STATIC (decl) && ! DECL_EXTERNAL (decl))
+	  error ("`chip' attribute cannot be specified for local variables");
+	else
+	  {
+	    /* The decl may have already been given a section attribute from
+	       a previous declaration.  Ensure they match.  */
+	    if (DECL_SECTION_NAME (decl) == NULL_TREE)
+	      DECL_SECTION_NAME (decl) =
+		build_string (strlen (AMIGA_CHIP_SECTION_NAME) + 1,
+			      AMIGA_CHIP_SECTION_NAME);
+	    else if (strcmp (TREE_STRING_POINTER (DECL_SECTION_NAME (decl)),
+			     AMIGA_CHIP_SECTION_NAME) != 0)
+	      {
+		error_with_decl (decl,
+			"`chip' for `%s' conflicts with previous declaration");
+		return 0;
+	      }
+	    return 1;
+	  }
+      }
+#else
+      error ("`chip' attribute is not supported for this target");
+#endif
+
+  return 0;
+}
+
+/* Return nonzero if IDENTIFIER with arguments ARGS is a valid machine
+   specific attribute for TYPE.  The attributes in ATTRIBUTES have previously
+   been assigned to TYPE.  */
+
+int
+valid_amigaos_type_attribute (type, attributes, identifier, args)
+     tree type, attributes, identifier, args;
+{
+  if (valid_m68k_type_attribute (type, attributes, identifier, args))
+    return 1;
+  else if (TREE_CODE (type) == FUNCTION_TYPE || TREE_CODE (type) == METHOD_TYPE)
+    {
+      if (is_attribute_p ("stackext", identifier))
+	{
+	  if (lookup_attribute ("interrupt", attributes))
+	    {
+	      error ("`stackext' and `interrupt' are mutually exclusive");
+	      return 0;
+	    }
+	  return 1;
+	}
+      if (is_attribute_p ("interrupt", identifier))
+	{
+	  if (lookup_attribute ("stackext", attributes))
+	    {
+	      error ("`stackext' and `interrupt' are mutually exclusive");
+	      return 0;
+	    }
+	  return 1;
+	}
+      if (is_attribute_p ("saveds", identifier))
+	return 1;
+    }
+
+  return 0;
+}
+
+/* Stack checking and automatic extension support.  */
+
+void
+amigaos_prologue_begin_hook (stream, fsize)
+     FILE *stream;
+     int fsize;
+{
+  if (TARGET_STACKCHECK)
+    {
+      if (fsize < 256)
+	asm_fprintf (stream, "\tcmpl %s,%Rsp\n"
+			     "\tjcc 0f\n"
+			     "\tjra %U__stkovf\n"
+			     "\t0:\n",
+		     (flag_pic == 3 ? "a4@(___stk_limit:W)" :
+				      (flag_pic == 4 ? "a4@(___stk_limit:L)" :
+						       "___stk_limit")));
+      else if (fsize < 0x8000)
+	asm_fprintf (stream, "\tmovel #%d:W,%Rd0\n\tjbsr %U__stkchk_d0\n",
+		     fsize);
+      else
+	asm_fprintf (stream, "\tmovel #%d,%Rd0\n\tjbsr %U__stkchk_d0\n",
+		     fsize);
+    }
+}
+
+void
+amigaos_alternate_frame_setup_f (stream, fsize)
+     FILE *stream;
+     int fsize;
+{
+  if (fsize < 128)
+    asm_fprintf (stream, "\tcmpl %s,%Rsp\n"
+			 "\tjcc 0f\n"
+			 "\tmoveq #%d,%Rd0\n"
+			 "\tmoveq #0,%Rd1\n"
+			 "\tjbsr %U__stkext_f\n"
+			 "0:\tlink %Ra5,#%d:W\n",
+		 (flag_pic == 3 ? "a4@(___stk_limit:W)" :
+				  (flag_pic == 4 ? "a4@(___stk_limit:L)" :
+						   "___stk_limit")),
+		 fsize, -fsize);
+  else if (fsize < 0x8000)
+    asm_fprintf (stream, "\tmovel #%d:W,%Rd0\n\tjbsr %U__link_a5_d0_f\n",
+		 fsize);
+  else
+    asm_fprintf (stream, "\tmovel #%d,%Rd0\n\tjbsr %U__link_a5_d0_f\n",
+		 fsize);
+}
+
+void
+amigaos_alternate_frame_setup (stream, fsize)
+     FILE *stream;
+     int fsize;
+{
+  if (! fsize)
+    asm_fprintf (stream, "\tcmpl %s,%Rsp\n"
+			 "\tjcc 0f\n"
+			 "\tmoveq #0,%Rd0\n"
+			 "\tmoveq #0,%Rd1\n"
+			 "\tjbsr %U__stkext_f\n"
+			 "0:\n",
+		 (flag_pic == 3 ? "a4@(___stk_limit:W)" :
+				  (flag_pic == 4 ? "a4@(___stk_limit:L)" :
+						   "___stk_limit")));
+  else if (fsize + 4 < 128)
+    asm_fprintf (stream, "\tcmpl %s,%Rsp\n"
+			 "\tjcc 0f\n"
+			 "\tmoveq #%d,%Rd0\n"
+			 "\tmoveq #0,%Rd1\n"
+			 "\tjbsr %U__stkext_f\n"
+			 "0:\taddw #%d,%Rsp\n",
+		 (flag_pic == 3 ? "a4@(___stk_limit:W)" :
+				  (flag_pic == 4 ? "a4@(___stk_limit:L)" :
+						   "___stk_limit")),
+		 fsize + 4, -(fsize + 4));
+  else if (fsize + 4 < 0x8000)
+    asm_fprintf (stream, "\tmovel #%d:W,%Rd0\n\tjbsr %U__sub_d0_sp_f\n",
+		 fsize + 4);
+  else
+    asm_fprintf (stream, "\tmovel %0I%d,%Rd0\n\tjbsr %U__sub_d0_sp_f\n",
+		 fsize + 4);
+}
+
+static rtx
+gen_stack_management_call (stack_pointer, arg, func)
+     rtx stack_pointer;
+     rtx arg;
+     char *func;
+{
+  rtx call_insn, call, seq, name;
+  start_sequence ();
+
+  /* Move arg to d0.  */
+  emit_move_insn (gen_rtx (REG, SImode, 0), arg);
+
+  /* Generate the function reference.  */
+  name = gen_rtx (SYMBOL_REF, Pmode, func);
+  SYMBOL_REF_FLAG (name) = 1;
+  /* If optimizing, put it in a psedo so that several loads can be merged
+     into one.  */
+  if (optimize && ! flag_no_function_cse)
+    name = copy_to_reg (name);
+
+  /* Generate the function call.  */
+  call = gen_rtx (CALL, VOIDmode, gen_rtx (MEM, FUNCTION_MODE, name),
+		  const0_rtx);
+  /* If we are doing stack extension, notify about the sp change.  */
+  if (stack_pointer)
+    call = gen_rtx (SET, VOIDmode, stack_pointer, call);
+
+  /* Generate the call instruction.  */
+  call_insn = emit_call_insn (call);
+  /* Stack extension does not change memory in an unpredictable way.  */
+  CONST_CALL_P (call_insn) = 1;
+  /* We pass an argument in d0.  */
+  CALL_INSN_FUNCTION_USAGE (call_insn) = gen_rtx (EXPR_LIST, VOIDmode,
+	gen_rtx (USE, VOIDmode, gen_rtx (REG, SImode, 0)), 0);
+
+  seq = gen_sequence ();
+  end_sequence ();
+  return seq;
+}
+
+rtx
+gen_stack_cleanup_call (stack_pointer, sa)
+     rtx stack_pointer;
+     rtx sa;
+{
+  return gen_stack_management_call (stack_pointer, sa, "__move_d0_sp");
+}
+
+void
+amigaos_alternate_allocate_stack (operands)
+     rtx *operands;
+{
+  if (TARGET_STACKEXTEND)
+    emit_insn ((rtx)gen_stack_management_call (stack_pointer_rtx, operands[1],
+					       "__sub_d0_sp"));
+  else
+    {
+      if (TARGET_STACKCHECK)
+	emit_insn ((rtx)gen_stack_management_call (0, operands[1],
+						   "__stkchk_d0"));
+      anti_adjust_stack (operands[1]);
+    }
+  emit_move_insn (operands[0], virtual_stack_dynamic_rtx);
+}
+
+/* begin-GG-local: explicit register specification for parameters */
+
+/* Initialize a variable CUM of type CUMULATIVE_ARGS
+   for a call to a function whose data type is FNTYPE.
+   For a library call, FNTYPE is 0.  */
+
+void
+amigaos_init_cumulative_args(CUMULATIVE_ARGS *cum, tree fntype)
+{
+  m68k_init_cumulative_args(cum, fntype);
+
+  if (fntype)
+    cum->formal_type=TYPE_ARG_TYPES(fntype);
+  else /* Call to compiler-support function. */
+    cum->formal_type=0;
+}
+
+/* Update the data in CUM to advance over an argument.  */
+
+void
+amigaos_function_arg_advance(CUMULATIVE_ARGS *cum)
+{
+  m68k_function_arg_advance(cum);
+
+  if (cum->formal_type)
+    cum->formal_type=TREE_CHAIN((tree)cum->formal_type);
+}
+
+/* A C expression that controls whether a function argument is passed
+   in a register, and which register. */
+
+struct rtx_def *
+amigaos_function_arg(CUMULATIVE_ARGS *cum, enum machine_mode mode,
+  tree type)
+{
+  tree asmtree;
+  if (cum->formal_type && TREE_VALUE((tree)cum->formal_type)
+      && (asmtree=lookup_attribute("asm",
+			TYPE_ATTRIBUTES(TREE_VALUE((tree)cum->formal_type)))))
+    {
+      int i;
+#if 0
+      /* See c-decl.c/push_parm_decl for an explanation why this doesn't work.
+       */
+      cum->last_arg_reg=TREE_INT_CST_LOW(TREE_VALUE(TREE_VALUE(asmtree)));
+#else
+      cum->last_arg_reg=TREE_INT_CST_LOW(TREE_VALUE(asmtree));
+#endif
+      cum->last_arg_len=HARD_REGNO_NREGS(cum->last_arg_reg, mode);
+
+      for (i=0; i<cum->last_arg_len; i++)
+	if (cum->regs_already_used & (1 << cum->last_arg_reg+i))
+	  {
+	    error("two parameters allocated for one register");
+	    break;
+	  }
+      return gen_rtx(REG, mode, cum->last_arg_reg);
+    }
+  else
+    return (struct rtx_def *)m68k_function_arg(cum, mode, type);
+}
+
+/* Return zero if the attributes on TYPE1 and TYPE2 are incompatible,
+   one if they are compatible, and two if they are nearly compatible
+   (which causes a warning to be generated). */
+
+int
+comp_amigaos_type_attributes(tree type1, tree type2)
+{
+  int ret;
+  if ((ret=comp_m68k_type_attributes(type1, type2))!=1)
+    return ret;
+
+  /* Functions or methods are incompatible if they specify mutually exclusive
+     ways of passing arguments. */
+  if (TREE_CODE(type1)==FUNCTION_TYPE || TREE_CODE(type1)==METHOD_TYPE)
+    {
+      tree arg1, arg2;
+      arg1=TYPE_ARG_TYPES(type1);
+      arg2=TYPE_ARG_TYPES(type2);
+      for (; arg1 && arg2; arg1=TREE_CHAIN(arg1), arg2=TREE_CHAIN(arg2))
+	if (TREE_VALUE(arg1) && TREE_VALUE(arg2))
+	  {
+	    tree asm1, asm2;
+	    asm1=lookup_attribute("asm", TYPE_ATTRIBUTES(TREE_VALUE(arg1)));
+	    asm2=lookup_attribute("asm", TYPE_ATTRIBUTES(TREE_VALUE(arg2)));
+	    if (asm1 && asm2)
+	      {
+		if (TREE_INT_CST_LOW(TREE_VALUE(asm1))!=
+		    TREE_INT_CST_LOW(TREE_VALUE(asm2)))
+		  return 0; /* Two different registers specified. */
+	      }
+	    else
+	      if (asm1 || asm2)
+		return 0; /* "asm" used in only one type. */
+	  }
+    }
+  return 1;
+}
+
+/* end-GG-local */
